#include "objLoader.h"
#include <iostream>
#include <cstdio>
#include <string>
using namespace std;

void objLoader::load(const char* fileName) {
	FILE *fdat = fopen(fileName, "r");
	
	char line[300];
	while(fgets(line, 300, fdat)) {
		if (line[0]=='#')
			continue;
		if (strstr(line, "g ")) {
			//fseek(fdat, fp, SEEK_SET);
			//break;
			continue;
		} else {
			char* key = strtok(line, " \t\n\r");
			if (!key)
				continue;
			if (key[0]=='v' && key[1]=='n') {
				Normal vi;
				char* valx = strtok(NULL, " \t\n\r");
				char* valy = strtok(NULL, " \t\n\r");
				char* valz = strtok(NULL, " \t\n\r");
				vi.x = (float)atof(valx);
				vi.y = (float)atof(valy);
				vi.z = (float)atof(valz);
				normals.push_back(vi);
			} else if (key[0]=='v' && key[1]=='t') {
			} else if (key[0]=='v') {
				Point vi(0,0,0,1);
				char* valx = strtok(NULL, " \t\n\r");
				char* valy = strtok(NULL, " \t\n\r");
				char* valz = strtok(NULL, " \t\n\r");
				vi.x = (float)atof(valx);
				vi.y = (float)atof(valy);
				vi.z = (float)atof(valz);
				points.push_back(vi);
			} else if (key[0]='f') {
				char* val = strtok(NULL, " \t\n\r");
				std::vector<unsigned int> face;
				for(;val!=NULL;val = strtok(NULL, " \t\n\r")) {
					unsigned int iv[3] = { 0, 0, 0 };	// 0:vtx, 1:tex, 2:nrm
					if (sscanf(val, "%d/%d/%d", iv+0,iv+1,iv+2)==3) {
						triangles.push_back(iv[0]-1);
						face.push_back(iv[0]-1);
					} else if (sscanf(val, "%d/%d", iv+0,iv+1)==2) {
						triangles.push_back(iv[0]-1);
						face.push_back(iv[0]-1);
					} else if (sscanf(val, "%d//%d", iv+0,iv+2)==2) {
						triangles.push_back(iv[0]-1);
						face.push_back(iv[0]-1);
					} else if (sscanf(val, "%d", iv+0)==1) {
						triangles.push_back(iv[0]-1);
						face.push_back(iv[0]-1);
					}
				}
				faces.push_back(face);
				nbEdges = face.size();
			}
		}
	}
	fclose(fdat);
}