#ifndef _OBJLOADER_
#define _OBJLOADER_

#include <vector>
#include "glm/glm.hpp"
#include "glm/gtc/type_ptr.hpp"
#include "glm/gtc/matrix_transform.hpp"

typedef glm::vec4 Point;
typedef glm::vec3 Normal;

class objLoader
{
public :
	std::vector<Point> points;
	std::vector<Normal> normals;
	std::vector<std::vector<unsigned int>> faces; // faces[i] = list of vertex indices of face i
	std::vector<unsigned int> triangles; // list of vertex indices : triangles[3*i] triangles[3*i+1] triangles[3*i+2] define a face
	int nbEdges;

public :
	objLoader() {
	}

	~objLoader() {
		points.clear();
		normals.clear();
		faces.clear();
		triangles.clear();
	}

	void load(const char* fileName);
};

#endif